# Class Vector3F

java.lang.Object
com.io7m.jtensors.core.unparameterized.vectors.Vector3F

All Implemented Interfaces:
  `Vector3FType, VectorReadable2FType, VectorReadable3FType, VectorComputationalType`

public final class Vector3F extends Object implements Vector3FType
The type of 3D `float`-typed vectors.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `Vector3F.Builder`
  Builds instances of type `Vector3F`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Vector3F.Builder`
  `builder()`
  Creates a builder for `Vector3F`.
  `static Vector3F`
  `copyOf(Vector3FType instance)`
  Creates an immutable copy of a `Vector3FType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `Vector3F` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `x`, `y`, `z`.
  `static Vector3F`
  `of(float x, float y, float z)`
  Construct a new immutable `Vector3F` instance.
  `String`
  `toString()`
  Prints the immutable value `Vector3F` with attribute values.
  `final Vector3F`
  `withX(float value)`
  Copy the current immutable object by setting a value for the `x` attribute.
  `final Vector3F`
  `withY(float value)`
  Copy the current immutable object by setting a value for the `y` attribute.
  `final Vector3F`
  `withZ(float value)`
  Copy the current immutable object by setting a value for the `z` attribute.
  `float`
  `x()`
  `float`
  `y()`
  `float`
  `z()`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### x

    public float x()
    Specified by:
      `x` in interface `Vector3FType`
    Specified by:
      `x` in interface `VectorReadable2FType`
    Returns:
      The value of the `x` attribute

  - ### y

    public float y()
    Specified by:
      `y` in interface `Vector3FType`
    Specified by:
      `y` in interface `VectorReadable2FType`
    Returns:
      The value of the `y` attribute

  - ### z

    public float z()
    Specified by:
      `z` in interface `Vector3FType`
    Specified by:
      `z` in interface `VectorReadable3FType`
    Returns:
      The value of the `z` attribute

  - ### withX

    public final Vector3F withX(float value)
    Copy the current immutable object by setting a value for the `x` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x
    Returns:
      A modified copy or the `this` object

  - ### withY

    public final Vector3F withY(float value)
    Copy the current immutable object by setting a value for the `y` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for y
    Returns:
      A modified copy or the `this` object

  - ### withZ

    public final Vector3F withZ(float value)
    Copy the current immutable object by setting a value for the `z` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for z
    Returns:
      A modified copy or the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `Vector3F` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `x`, `y`, `z`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `Vector3F` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static Vector3F of(float x, float y, float z)
    Construct a new immutable `Vector3F` instance.
    Parameters:
      `x` - The value for the `x` attribute
      `y` - The value for the `y` attribute
      `z` - The value for the `z` attribute
    Returns:
      An immutable Vector3F instance

  - ### copyOf

    public static Vector3F copyOf(Vector3FType instance)
    Creates an immutable copy of a `Vector3FType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable Vector3F instance

  - ### builder

    public static Vector3F.Builder builder()
    Creates a builder for `Vector3F`.

        Vector3F.builder()
           .setX(float) // required x
           .setY(float) // required y
           .setZ(float) // required z
           .build();

    Returns:
      A new Vector3F builder